﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ModbusDemo.MessageFormat;
using ModbusDemo.Common;
namespace ModbusDemo.Modular
{
    class ModualPoll
    {
        const byte  byX14pNumber                                = 3;
        const byte  byX14pReadDataStartAddress                  = 0;
        const byte  byX14pReadDataNumber                        = 4;
        const byte byX14pReadTypeStartAddress                   = 10;
        const byte byX14pReadTypeNumber                         = 4;

        const double dX14pMinCovertData                         = 0;
        const double dx14pMaxConverData                         = 60;
        const ushort us14pMaxJumTemper                          = 10;
        static byte[] byX14pIdlist                              = {17,28,29};
        modual.pcx14P cx14P = new modual.pcx14P(byX14pIdlist);
        _414P c14formulasormual = new _414P();

        const byte  byX18xNumber                                = 6;
        const byte  byX18xReadDataStartAddress                  = 0;
        const byte  byX18xReadDataNumber                        = 8;
        const byte  byX18xReadTypeStartAddress                  = 10;
        const byte  byX18xReadTypeNumber                        = 8;

        const double dX18xMinConvertData                        = 0;
        const ushort dX18xMaxJumpData                           = 2;
        static byte[] byX18xIdlist                              = {12,13,21,25,45,53};
        static modual.eX18xSensorChannelType[,] sX18xChannelType =  new modual.eX18xSensorChannelType[byX18xNumber,byX18xReadDataNumber]{{modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal},
                                                                                                                                              {modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal},
                                                                                                                                              {modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal},
                                                                                                                                              {modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal},
                                                                                                                                              {modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal},
                                                                                                                                              {modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal,modual.eX18xSensorChannelType.Normal}};        
         
        modual.pcx18X cx18x = new modual.pcx18X(byX18xIdlist, sX18xChannelType);
        _418X  c18xformulasormual= new _418X();


        const byte  byX78cNumber                                = 6;
        const byte  byX78cInputRegStartAddress                  = 0;
        const byte  byX78cInputRegNumber                        = 8;
        const byte byX78cOutputRegStartAddress                  = 16;
        const byte byX78cOutputRegNumber                        = 8;
        static byte[] byX78cIdlist                              = {11,20,33,34,55,56};
        modual.pcx78C cx78c = new modual.pcx78C(byX78cIdlist);

        
        const byte  byX66cNumber                                = 32;
        const byte  byX66cRelayRegStartAddress                  = 16;
        const byte  byX66cRelayRegNumber                        = 6;
        static byte[] byX66cIdlist                              = {9,10,14,15,16,19,22,23,24,26,30,31,32,35,36,37,38,39,40,41,42,43,44,46,47,48,49,50,51,52,54,57};
        modual.pcx66C cx66c = new modual.pcx66C(byX66cIdlist);
        void vAllNodePoll()
        {
            for (byte i = 0; i < byX14pNumber; i++)
            {
                ModbusComm.eModbusErrorCode  ModbusErrorCode = ModbusComm.eModbusErrorCode.MB_EMASTERNOERR;
                string[][] sTempString = new string[byX14pNumber][];
                ModbusErrorCode |= ModbusComm.Modbus_ReadHoldingRegistersTask(out cx14P.sX14pDataStruct[i].usX14pRegData, cx14P.byModbusID[i], byX14pReadDataStartAddress, byX14pReadDataNumber);
                ModbusErrorCode |= ModbusComm.Modbus_ReadHoldingRegistersTask(out cx14P.sX14pDataStruct[i].usX14pRegType, cx14P.byModbusID[i], byX14pReadTypeStartAddress, byX14pReadTypeNumber);
                sTempString[i] = c14formulasormual.RtdValue(cx14P.sX14pDataStruct[i].usX14pRegData, cx14P.sX14pDataStruct[i].usX14pRegType);
                if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                {
                    for (byte j = 0; j < byX14pReadTypeNumber; j++)
                    {
                        cx14P.sX14PAlarmStruct[i].eNowAlarmCode[j] |= ModualAlarm.eAlarmCode.ChannelCommunError;
                    }
                }
                else
                {
                    for (byte j = 0; j < byX14pReadTypeNumber; j++)
                    {
                        cx14P.sX14PAlarmStruct[i].eNowAlarmCode[j] &= ~ModualAlarm.eAlarmCode.ChannelCommunError;
                    }

                }

                for (byte j = 0; j < byX14pReadTypeNumber; j++)
                {
                    cx14P.sX14pDataStruct[i].dX14pNowConvertData[j] = double.Parse(sTempString[i][j]);
                    //if (cx14P.sX14pDataStruct[i].dX14pNowConvertData[j]  <= dX14pMinCovertData  || cx14P.sX14pDataStruct[i].dX14pNowConvertData[j] >= dx14pMaxConverData )
                    //{
                    //    cx14P.sX14PAlarmStruct[i].eNowAlarmCode[j] |= ModualAlarm.eAlarmCode.ChannelCollectDataError;
                    //}
                    if (cx14P.sX14PAlarmStruct[i].bDataNotFirstIncreaseOrDecrease == true)
                    {
                        if (cx14P.sX14pDataStruct[i].dX14pNowConvertData[j] - cx14P.sX14pDataStruct[i].dX14pBeforeConvertData[j] >= us14pMaxJumTemper && cx14P.sX14pDataStruct[i].dX14pBeforeConvertData[j] - cx14P.sX14pDataStruct[i].dX14pNowConvertData[j] >= us14pMaxJumTemper)
                        {
                            cx14P.sX14PAlarmStruct[i].eNowAlarmCode[j] |= ModualAlarm.eAlarmCode.ChannelDataChangeError;
                        }
                        else
                        {
                            cx14P.sX14PAlarmStruct[i].eNowAlarmCode[j] &= ~ModualAlarm.eAlarmCode.ChannelDataChangeError;
                        }
                    }

                    cx14P.sX14PAlarmStruct[i].eBeforeAlarmCode[j] = cx14P.sX14PAlarmStruct[i].eNowAlarmCode[j];
                }
                cx14P.sX14PAlarmStruct[i].bDataNotFirstIncreaseOrDecrease = true;
            }

            for (byte i = 0; i < byX18xNumber; i++)
            {
                ModbusComm.eModbusErrorCode ModbusErrorCode = ModbusComm.eModbusErrorCode.MB_EMASTERNOERR;
                string[][] sTempString = new string[byX18xNumber][];
                ModbusErrorCode |= ModbusComm.Modbus_ReadHoldingRegistersTask(out cx18x.sX18xDataStruct[i].usRegData, cx18x.byModbusID[i], byX18xReadDataStartAddress, byX18xReadDataNumber);
                ModbusErrorCode |= ModbusComm.Modbus_ReadHoldingRegistersTask(out cx18x.sX18xDataStruct[i].usTypeData, cx18x.byModbusID[i], byX18xReadTypeStartAddress, byX18xReadTypeNumber);
                sTempString[i] = c18xformulasormual.Value(cx14P.sX14pDataStruct[i].usX14pRegData, cx14P.sX14pDataStruct[i].usX14pRegType);
                if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                {
                    for (sbyte j = 0; j < byX18xReadTypeNumber; j++)
                    {
                        cx18x.sX18xAlarmstruct[i].eNowAlarmCode[j] |= ModualAlarm.eAlarmCode.ChannelCommunError;
                    }
                }
                else
                {
                    for (sbyte j = 0; j < byX18xReadTypeNumber; j++)
                    {
                        cx18x.sX18xAlarmstruct[i].eNowAlarmCode[j] |= ~ModualAlarm.eAlarmCode.ChannelCommunError;
                    }
                }

                for (byte j = 0; j < byX18xReadTypeNumber; j++)
                {
                    if (cx18x.sX18xDataStruct[i].eChannelType[j] == modual.eX18xSensorChannelType.Normal)
                        cx18x.sX18xDataStruct[i].dNowConvertData[j] = (double.Parse(sTempString[i][j]) - 4) / 16 * 6;
                    if (cx18x.sX18xAlarmstruct[i].bDataNotFirstIncreaseOrDecrease == true)
                    {
                        if (cx18x.sX18xDataStruct[i].dNowConvertData[j] - cx18x.sX18xDataStruct[i].dBeforeConvertData[j] >= dX18xMaxJumpData || cx18x.sX18xDataStruct[i].dBeforeConvertData[j] - cx18x.sX18xDataStruct[i].dNowConvertData[j] >= dX18xMaxJumpData)
                        {
                            cx18x.sX18xAlarmstruct[i].eNowAlarmCode[j] |= ModualAlarm.eAlarmCode.ChannelDataChangeError;
                        }
                        else
                        {
                            cx18x.sX18xAlarmstruct[i].eNowAlarmCode[j] &= ~ModualAlarm.eAlarmCode.ChannelDataChangeError;
                        }
                    }
                    cx18x.sX18xDataStruct[i].dBeforeConvertData[j] = cx18x.sX18xDataStruct[i].dNowConvertData[j];
                }
                cx18x.sX18xAlarmstruct[i].bDataNotFirstIncreaseOrDecrease = true;
            }
            for (byte i = 0; i < byX78cNumber; i++)
            {
                ModbusComm.eModbusErrorCode ModbusErrorCode = ModbusComm.eModbusErrorCode.MB_EMASTERNOERR;
                ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out cx78c.sX78cRegStatusStruct[i].bInputRegStatus,  cx78c.byModbusID[i], byX78cInputRegStartAddress,  byX78cInputRegNumber);
                ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out cx78c.sX78cRegStatusStruct[i].bOutPutRegStatus, cx78c.byModbusID[i], byX78cOutputRegStartAddress, byX78cOutputRegNumber);
                if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                {
                    for (sbyte j = 0; j < byX78cInputRegNumber + byX78cOutputRegNumber; j++)
                    {
                        cx78c.sX78cAlarmStruct[i].eNowAlarmCode[j] |= ModualAlarm.eAlarmCode.ChannelCommunError;
                    }
                }
                else
                {
                    for (sbyte j = 0; j < byX78cInputRegNumber + byX78cOutputRegNumber; j++)
                    {
                        cx78c.sX78cAlarmStruct[i].eNowAlarmCode[j] &= ~ModualAlarm.eAlarmCode.ChannelCommunError;
                    }
                }
            }

            for (byte i = 0; i < byX66cNumber; i++)
            {
                ModbusComm.eModbusErrorCode ModbusErrorCode = ModbusComm.eModbusErrorCode.MB_EMASTERNOERR;
                ModbusErrorCode =  ModbusComm.Modbus_ReadCoilsTask(out cx66c.sX66cRegStatusStruct[i].bOutPutRegStatus, cx66c.byModbusID[i], byX66cRelayRegStartAddress, byX66cRelayRegNumber);
                if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                {
                    for (sbyte j = 0; j < byX66cRelayRegNumber; j++)
                    {
                        cx66c.sX66cAlarmStruct[i].eNowAlarmCode[j] |= ModualAlarm.eAlarmCode.ChannelCommunError;
                    }
                }
                else
                {
                    for (sbyte j = 0; j < byX66cRelayRegNumber; j++)
                    {
                        cx66c.sX66cAlarmStruct[i].eNowAlarmCode[j] &= ~ModualAlarm.eAlarmCode.ChannelCommunError;
                    }
                }
            }
        }

        void vCheckAlarm()
        {
            for (byte i = 0; i < byX14pNumber; i++)
            {
                for (byte j = 0; j < byX14pReadDataNumber; j++)
                {
                    if (cx14P.sX14PAlarmStruct[i].eNowAlarmCode[j] != cx14P.sX14PAlarmStruct[i].eBeforeAlarmCode[j])
                    {

                    }
                }
            }



        }
    }
}
