﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ModbusDemo.MessageFormat;
using ModbusDemo.Common;
namespace ModbusDemo.Modular
{
    class modual
    {
        public struct psx14pData
        {
            public ushort[]  usX14pRegData;
            public ushort[]  usX14pRegType;
            public double[]  dX14pNowConvertData;
            public double[]  dX14pBeforeConvertData;
        }
        public struct psxModualAlarm
        {
            public bool   bDataNotFirstIncreaseOrDecrease;
            public ModualAlarm.eAlarmCode[] eNowAlarmCode;
            public ModualAlarm.eAlarmCode[] eBeforeAlarmCode;

        }
        public class pcx14P
        {
            public byte[]                          byModbusID;
            public psx14pData[]                    sX14pDataStruct;
            public psxModualAlarm[]                sX14PAlarmStruct;
            public ModbusComm.eModbusErrorCode[]   ModbusErrorCode;
            public pcx14P(byte[] InitIDlist)
            {
                this.byModbusID = InitIDlist; 
            }
        }
        public enum eX18xSensorChannelType : byte
        {
            Normal = 0,
            Level,
        }

        public struct psX18xData
        {
            public ushort[]                     usRegData;
            public ushort[]                     usTypeData;
            public eX18xSensorChannelType[]     eChannelType;
            public double[]                     dNowConvertData;
            public double[]                     dBeforeConvertData;
        }
        public class pcx18X
        {
            public  byte[]                         byModbusID;
            public  psX18xData[]                   sX18xDataStruct;
            public psxModualAlarm[]                sX18xAlarmstruct;
            public ModbusComm.eModbusErrorCode[]   ModbusErrorCode;
            public pcx18X(byte[] InitIDlist, eX18xSensorChannelType[,] eChannnelType)
            {
                this.byModbusID         = InitIDlist;
                for (ushort i = 0; i < eChannnelType.GetLength(0); i++)
                {
                    for (ushort j = 0; j < eChannnelType.GetLength(1); j++)
                    {
                        this.sX18xDataStruct[i].eChannelType[j] = eChannnelType[i,j];
                    }
                }
            }
        }
        public struct psx78C
        {
            public bool[] bInputRegStatus;
            public bool[] bOutPutRegStatus;
            public bool   bX78cAllChannelAlarm;
        }
        public class pcx78C
        {
            public byte[]                              byModbusID;
            public psx78C[]                            sX78cRegStatusStruct;
            public psxModualAlarm[]                    sX78cAlarmStruct;
            public ModbusComm.eModbusErrorCode[]       ModbusErrorCode;
            public pcx78C(byte[] InitIDlist)
            {
                this.byModbusID = InitIDlist;
            }
        }
        public struct psx66C
        {
            public bool[] bRegRelayStatus;
            public bool[] bX66CAllChannelAlarm;
        }
        public class pcx66C
        {
            public byte[]                          byModbusID;
            public psx78C[]                        sX66cRegStatusStruct;
            public psxModualAlarm[]                sX66cAlarmStruct;
            public ModbusComm.eModbusErrorCode[]   ModbusErrorCode;
            public pcx66C(byte[] InitIDlist)
            {
                this.byModbusID = InitIDlist;
            }
        }
    }
}
